#ifndef CHROMEOS_CAMERA_LIB_BLAZEFACE_BLAZEFACE_SHORT_RANGE_CPU_CLIENT_CROS_WRAPPER_H_
#define CHROMEOS_CAMERA_LIB_BLAZEFACE_BLAZEFACE_SHORT_RANGE_CPU_CLIENT_CROS_WRAPPER_H_

#include <cstdint>
#include <memory>
#include <vector>

#include "chromeos/camera/lib/blazeface/face_detection_cros_wrapper.h"
#include "third_party/absl/strings/string_view.h"
#include "third_party/mediapipe/framework/calculator_framework.h"
#include "third_party/mediapipe/framework/output_stream_poller.h"

namespace cros {

class BlazefaceShortRangeCpuClientCrosWrapper
      : public cros::FaceDetectionCrosWrapper{
 public:
  BlazefaceShortRangeCpuClientCrosWrapper() = default;
  ~BlazefaceShortRangeCpuClientCrosWrapper() override;

  // Returns true if initialized successfully.
  bool Initialize(absl::string_view graph_file);

  // Returns true if detecting faces successfully even there is no face.
  // |data| is the address of Y plane of YCbCr color space.
  bool Detect(
      const uint8_t* data, int width, int height,
      std::vector<human_sensing::CrosFace>* cros_faces) override;

 private:
    mediapipe::CalculatorGraph graph_;
    std::unique_ptr<mediapipe::OutputStreamPoller> poller_;
};

}  // namespace cros
#endif  // CHROMEOS_CAMERA_LIB_BLAZEFACE_BLAZEFACE_SHORT_RANGE_CPU_CLIENT_CROS_WRAPPER_H_
